﻿// Basic Ticker Sprite - Actionscript 3 - Jim Bumgardner 2008

package {
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.display.Sprite;
	import flash.utils.getTimer;

	public class BasicTickerSprite extends Sprite
	{
		static const kEffectDuration = 2000;
		static const kReadDuration = 2000;

		public static var mcCtr = 0;
		static var tickerItems = [];
		static var tickerMCs = [];
		static var tickerIdx = 0;
		

		var mc:ticker_mc;

		var speed;
		var idx;
		// var srcScale, srcX, srcY, srcAlpha, dstScale, dstX, dstY, dstAlpha;
		
		public function BasicTickerSprite(idx)
		{
			mc = new ticker_mc();
			this.idx = idx;
			addChild(mc);
			mc.ticker_txt.autoSize = "left";
			// mc.ticker_txt.html = true;
			speed = 10;
			addEventListener(MouseEvent.MOUSE_MOVE, myMouseMove);
			addEventListener(Event.ENTER_FRAME, cycleTicker);
			
		}
		
		public static function setTickerItems(itsItems)
		{
			tickerItems = itsItems;
		}

		public static function addTickerItem(itsItem)
		{
			tickerItems.push(itsItem);
		}
		
		public static function startTicker(parMC)
		{
			var mc = new BasicTickerSprite(0);
			parMC.addChild(mc);
			tickerMCs.push(mc);

			mc = new BasicTickerSprite(1);
			parMC.addChild(mc);
			tickerMCs.push(mc);
						
			tickerMCs[0].getTickerItem(0);
			tickerMCs[1].visible = false;
		}
		
		function myMouseMove(evt)
		{
			if (mouseY <= stage.stageHeight/3 && mouseY >= -stage.stageHeight/3)
				speed = 2; 
			else
				speed = 10; 
 		}

		public function getTickerItem(n)
		{
			visible = true;
			this.idx = n;
			mc.ticker_txt.htmlText = tickerItems[n];
			mc.ticker_txt.x = 0;
			mc.ticker_txt.y = -mc.ticker_txt.textHeight/2;
			this.x = stage.stageWidth;
			this.y = stage.stageHeight/2;
		}

		// This function animates the text
		//
		function cycleTicker(evt)
		{
			if (!visible)
				return;
		
			this.x -= this.speed;

			if (this.x <= -mc.ticker_txt.textWidth) 
			{
				this.visible = false;
				mcCtr = (mcCtr + 1) % 2;
				tickerIdx = (tickerIdx+1) % tickerItems.length;
				tickerMCs[mcCtr].getTickerItem(tickerIdx);
			}
		}			
		
	} // end class
	

} // end package
